local Vremon = CreateFrame("Frame")

-- Confing Panel

local AddOn_Name = ...
local AddOn_Title = select(2, GetAddOnInfo(AddOn_Name)) or AddOn_Name

--  Options Panel Layout
local OptionsPanel = CreateFrame("Frame");

local TitleText =
    OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal");
TitleText:SetPoint("TOP", 0, -5);
TitleText:SetText([[Vremon UI v4.5 Dragonflight

This AddOn help you to clean or setup Blizzard Default Interface for a better visibility.]]);

---  Options Panel Registration & Callbacks
OptionsPanel.name = AddOn_Title; --    Category name
OptionsPanel.refresh = function() --   Runs when our Options Panel is shown

end;

InterfaceOptions_AddCategory(OptionsPanel); --   Register our Options Panel

local function Vremon_OnLoad()
    VREMON_STATE_DISABLED = VREMON_STATE_DISABLED or {}

    local function BlackGate(functionName)
        local t = CreateFrame("CheckButton", nil, OptionsPanel,
                              "UICheckButtonTemplate");
        t:SetPoint("TOPLEFT", 24, -48);
        t:SetScript("OnClick",
                    function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t
    end
    local t = BlackGate("Black")
    t:SetSize(35, 35)
    t:SetChecked(not VREMON_STATE_DISABLED["Black"])
    local text = OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text:SetPoint("LEFT", t, "RIGHT")
    text:SetText("BlackGate Skin(recolor most of the texture to black)")

    local function ClassPortrait(functionName)
        local t1 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t1:SetPoint("TOPLEFT", 24, -78);
        t1:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t1
    end

    local t1 = ClassPortrait("Portrait")
    t1:SetSize(35, 35)
    t1:SetChecked(not VREMON_STATE_DISABLED["Portrait"])
    local text1 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text1:SetPoint("LEFT", t1, "RIGHT")
    text1:SetText("ClassIcon Portraits(on Target/Focus Frame Portrait)")
	
	local function NameplateIcon(functionName)
        local t2 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t2:SetPoint("TOPLEFT", 24, -108);
        t2:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t2
    end

    local t2 = NameplateIcon("HideNameplates")
    t2:SetSize(35, 35)
    t2:SetChecked(not VREMON_STATE_DISABLED["HideNameplates"])
    local text2 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text2:SetPoint("LEFT", t2, "RIGHT")
    text2:SetText("Show Nameplates NameToIcon(such as Psyfiend,Totems,Warlock Pets,War Banner)")
	
	local function HideKeybidingsName(functionName)
        local t3 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t3:SetPoint("TOPLEFT", 24, -138);
        t3:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t3
    end

    local t3 = HideKeybidingsName("HideKeybinds")
    t3:SetSize(35, 35)
    t3:SetChecked(not VREMON_STATE_DISABLED["HideKeybinds"])
    local text3 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text3:SetPoint("LEFT", t3, "RIGHT")
    text3:SetText("Hide Keybindings Name")
	
	local function HideMacrosName(functionName)
        local t4 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t4:SetPoint("TOPLEFT", 24, -168);
        t4:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t4
    end

    local t4 = HideMacrosName("HideMacro")
    t4:SetSize(35, 35)
    t4:SetChecked(not VREMON_STATE_DISABLED["HideMacro"])
    local text4 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text4:SetPoint("LEFT", t4, "RIGHT")
    text4:SetText("Hide Macros Name")
	
	
	local function CVarlist(functionName)
        local t5 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t5:SetPoint("TOPLEFT", 24, -198);
        t5:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t5
    end

    local t5 = CVarlist("CVar")
    t5:SetSize(35, 35)
    t5:SetChecked(not VREMON_STATE_DISABLED["CVar"])
    local text5 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text5:SetPoint("LEFT", t5, "RIGHT")
    text5:SetText("Disable Nameplates Transparency")
	
	local function BDsizerows(functionName)
        local t6 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t6:SetPoint("TOPLEFT", 24, -228);
        t6:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t6
    end

    local t6 = BDsizerows("SizeRowsBD")
    t6:SetSize(35, 35)
    t6:SetChecked(not VREMON_STATE_DISABLED["SizeRowsBD"])
    local text6 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text6:SetPoint("LEFT", t6, "RIGHT")
    text6:SetText("Enable 2 first rows of 4 Buffs/Debuffs and Size on Target/Focus Frame")
	
	
    local function PlayerHealthBar(functionName)
        local t7 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t7:SetPoint("TOPLEFT", 24, -258);
        t7:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t7
    end

    local t7 = PlayerHealthBar("UnitFrameHealthBar_OnColorUpdate")
    t7:SetSize(35, 35)
    t7:SetChecked(not VREMON_STATE_DISABLED["UnitFrameHealthBar_OnColorUpdate"])
    local text7 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text7:SetPoint("LEFT", t7, "RIGHT")
    text7:SetText("Show ClassColored HealthBar for Target/Focus Frame")
	
	
	local function PortraitNumbers(functionName)
        local t8 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t8:SetPoint("TOPLEFT", 24, -498);
        t8:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t8
    end

    local t8 = PortraitNumbers("PortraitHitNumbers")
    t8:SetSize(35, 35)
    t8:SetChecked(not VREMON_STATE_DISABLED["PortraitHitNumbers"])
    local text8 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text8:SetPoint("LEFT", t8, "RIGHT")
    text8:SetText("Hide PlayerFrame Portrait HitIndicator Damage/Healing Numbers")
	
	
	local function FrendlyNameplateClassC(functionName)
        local t9 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t9:SetPoint("TOPLEFT", 24, -318);
        t9:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t9
    end

    local t9 = FrendlyNameplateClassC("FrendlyNCC")
    t9:SetSize(35, 35)
    t9:SetChecked(not VREMON_STATE_DISABLED["FrendlyNCC"])
    local text9 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text9:SetPoint("LEFT", t9, "RIGHT")
    text9:SetText("Disable Friendly Nameplates ClassColor")
	
	local function CombatTextN(functionName)
        local t10 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t10:SetPoint("TOPLEFT", 24, -348);
        t10:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t10
    end

    local t10 = CombatTextN("CompactTextDamage")
    t10:SetSize(35, 35)
    t10:SetChecked(not VREMON_STATE_DISABLED["CompactTextDamage"])
    local text10 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text10:SetPoint("LEFT", t10, "RIGHT")
    text10:SetText("CompactCombatText Damage/Healing Numbers above Nameplates")
	
	
	local function UIErrorFrame(functionName)
        local t11 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t11:SetPoint("TOPLEFT", 24, -378);
        t11:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t11
    end

    local t11 = UIErrorFrame("ErrorRedText")
    t11:SetSize(35, 35)
    t11:SetChecked(not VREMON_STATE_DISABLED["ErrorRedText"])
    local text11 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text11:SetPoint("LEFT", t11, "RIGHT")
    text11:SetText("Hide UIError Red Text such as:You have no target etc.")
	
	
	local function TargetofTarget(functionName)
        local t12 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t12:SetPoint("TOPLEFT", 24, -408);
        t12:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t12
    end

    local t12 = TargetofTarget("TFToT")
    t12:SetSize(35, 35)
    t12:SetChecked(not VREMON_STATE_DISABLED["TFToT"])
    local text12 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text12:SetPoint("LEFT", t12, "RIGHT")
    text12:SetText("Target of Target Repositioned, uncheck to get default blizzard position ")
	
	
	local function EliteDragon(functionName)
        local t13 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t13:SetPoint("TOPLEFT", 24, -438);
        t13:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t13
    end

    local t13 = EliteDragon("EliteP")
    t13:SetSize(35, 35)
    t13:SetChecked(not VREMON_STATE_DISABLED["EliteP"])
    local text13 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text13:SetPoint("LEFT", t13, "RIGHT")
    text13:SetText("Show EliteDragon on PlayerFrame")
	
	
	local function EliteDragonT(functionName)
        local t14 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t14:SetPoint("TOPLEFT", 24, -468);
        t14:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t14
    end

    local t14 = EliteDragonT("EliteT")
    t14:SetSize(35, 35)
    t14:SetChecked(not VREMON_STATE_DISABLED["EliteT"])
    local text14 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text14:SetPoint("LEFT", t14, "RIGHT")
    text14:SetText("Show EliteDragon on TargetFrame")
	
	local function PlayerHealthC(functionName)
        local t15 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t15:SetPoint("TOPLEFT", 24, -288);
        t15:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t15
    end

    local t15 = PlayerHealthC("UnitFrameHealthBar_OnColorUpdate_PlayerOnly")
    t15:SetSize(35, 35)
    t15:SetChecked(not VREMON_STATE_DISABLED["UnitFrameHealthBar_OnColorUpdate_PlayerOnly"])
    local text15 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text15:SetPoint("LEFT", t15, "RIGHT")
    text15:SetText("Show ClassColored HealthBar for PlayerFrame")
	
	
	local function StatusHXR(functionName)
        local t16 = CreateFrame("CheckButton", nil, OptionsPanel,
                               "UICheckButtonTemplate");
        t16:SetPoint("TOPLEFT", 24, -528);
        t16:SetScript("OnClick",
                     function(self) --  Fire on user click (Toggles check status)
            VREMON_STATE_DISABLED[functionName] =
                not VREMON_STATE_DISABLED[functionName]
            ReloadUI()
        end)
        return t16
    end

    local t16 = StatusHXR("HXRbar")
    t16:SetSize(35, 35)
    t16:SetChecked(not VREMON_STATE_DISABLED["HXRbar"])
    local text16 =
        OptionsPanel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    text16:SetPoint("LEFT", t16, "RIGHT")
    text16:SetText("Hide Honor/Reputation/Xp Bar")
	
	
	

    --Target Frame Elite Dragon 

    local function EliteT(self)
	if not VREMON_STATE_DISABLED["EliteT"] then
    local function TargetFrame_CheckClassification(self)

                local ElitePortrait = self.TargetFrameContainer
                                          .BossPortraitFrameTexture
                local unitId = self.unit or self:GetParent().unit
                if unitId and UnitIsUnit(unitId, "target") then
                    ElitePortrait:SetAtlas(
                        "UI-HUD-UnitFrame-Target-PortraitOn-Boss-Gold",
                        TextureKitConstants.UseAtlasSize);
                    ElitePortrait:SetPoint("TOPRIGHT", -13, -6);
                    ElitePortrait:Show();
                else
                    ElitePortrait:Hide()
                end
				if  not  VREMON_STATE_DISABLED["Black"] then
				ElitePortrait:SetDesaturated(true)
                ElitePortrait:SetVertexColor(0.53, 0.53, 0.53)
				end	

            end
            hooksecurefunc(TargetFrame, "CheckClassification",
                           TargetFrame_CheckClassification);
    end
    end
	EliteT()

   --Player Frame Elite Dragon
   
   local function EliteP(self)
   if not VREMON_STATE_DISABLED["EliteP"] then
   local EliteGP = CreateFrame("Frame", nil,
                                        PlayerFrame.PlayerFrameContainer)
            EliteGP.TF = EliteGP:CreateTexture(nil, "BACKGROUND")
            EliteGP.TF:SetPoint("LEFT", PlayerFrame.PlayerFrameContainer,
                                "CENTER", -103, 2)
            EliteGP.TF:SetAtlas("UI-HUD-UnitFrame-Target-PortraitOn-Boss-Gold",
                                true)
            EliteGP.TF:SetTexCoord(1, 0, 0, 1)
   if  not  VREMON_STATE_DISABLED["Black"] then 
            EliteGP.TF:SetVertexColor(0.53, 0.53, 0.53)
            EliteGP.TF:SetDesaturated(true)
   end
   end
   end
   EliteP()


    -- BlackGate Config

    local function Black(self)
        if not VREMON_STATE_DISABLED["Black"] then
		
            for i = 1, 12 do
                _G["ActionButton" .. i .. "NormalTexture"]:SetVertexColor(0.23,
                                                                          0.23,
                                                                          0.23)
                _G["MultiBarBottomRightButton" .. i .. "NormalTexture"]:SetVertexColor(
                    0.23, 0.23, 0.23)
                _G["MultiBarBottomLeftButton" .. i .. "NormalTexture"]:SetVertexColor(
                    0.23, 0.23, 0.23)
                _G["MultiBarRightButton" .. i .. "NormalTexture"]:SetVertexColor(
                    0.23, 0.23, 0.23)
                _G["MultiBarLeftButton" .. i .. "NormalTexture"]:SetVertexColor(
                    0.23, 0.23, 0.23)
                _G["MultiBar5Button" .. i .. "NormalTexture"]:SetVertexColor(
                    0.23, 0.23, 0.23)
                _G["MultiBar6Button" .. i .. "NormalTexture"]:SetVertexColor(
                    0.23, 0.23, 0.23)
                _G["MultiBar7Button" .. i .. "NormalTexture"]:SetVertexColor(
                    0.23, 0.23, 0.23)
            end

			for i = 1, 10 do
                _G["PetActionButton" .. i .. "NormalTexture"]:SetVertexColor(
                    0.23, 0.23, 0.23)
                _G["StanceButton" .. i .. "NormalTexture"]:SetVertexColor(0.23,
                                                                          0.23,
                                                                          0.23)
            end
			

			for i, v in pairs({
            MainMenuBar.BorderArt,
            ActionButton1.RightDivider,
            ActionButton2.RightDivider,
            ActionButton3.RightDivider,
            ActionButton4.RightDivider,
            ActionButton5.RightDivider,
            ActionButton6.RightDivider,
            ActionButton7.RightDivider,
            ActionButton8.RightDivider,
            ActionButton9.RightDivider,
            ActionButton10.RightDivider,
            ActionButton11.RightDivider,      
        }) do
            v:SetVertexColor(0.23, 0.23, 0.23)
        end
		
		    MainMenuBar.EndCaps.LeftEndCap:SetVertexColor(0.53, 0.53, 0.53)
			MainMenuBar.EndCaps.RightEndCap:SetVertexColor(0.53, 0.53, 0.53)

			for i, v in pairs({
            TargetFrame.TargetFrameContainer.FrameTexture,
            FocusFrame.TargetFrameContainer.FrameTexture,
            PlayerFrame.PlayerFrameContainer.FrameTexture, 
            PetFrameTexture    ,      
            FocusFrameToT.FrameTexture,
            TargetFrameToT.FrameTexture,
            MinimapCompassTexture,
        }) do
            v:SetDesaturated(true)
            v:SetVertexColor(0.23, 0.23, 0.23)
        end			      
    end
    end
    Black()

    -- ClassIcon Portraits

    local function Portrait(self)
        if not VREMON_STATE_DISABLED["Portrait"] then

            local ValidUnits = {
                ["target"] = TargetFrameToT,
                ["focus"] = FocusFrameToT
            }

            local function UpdatePortrait(self)
                local Class
                local unitId = self.unit or self:GetParent().unit
                if unitId and UnitIsPlayer(unitId) then
                    Class = select(2, UnitClass(unitId))
                end
                if not Class then
                    SetPortraitTexture(self.ClassIcon, unitId)
                    self.ClassIcon:SetTexCoord(0, 1, 0, 1)
                    return
                end
                self.ClassIcon:SetAtlas(GetClassAtlas(strlower(Class)))
            end

            local function CreateIcon(self)
                self.ClassIcon = self:CreateTexture()
                local f = self.ClassIcon
                f:SetAllPoints(self.Portrait)

                local mask = self:CreateMaskTexture()
                mask:SetAllPoints(self.Portrait)
                mask:SetTexture(
                    "Interface\\CharacterFrame\\TempPortraitAlphaMask",
                    "CLAMPTOBLACKADDITIVE", "CLAMPTOBLACKADDITIVE")
                self.ClassIcon:AddMaskTexture(mask)

                f:SetDrawLayer(self.Portrait:GetDrawLayer(), 1)
                self:HookScript("OnShow", UpdatePortrait)
                UpdatePortrait(self)
            end
            
            CreateIcon(TargetFrame.TargetFrameContainer)
            CreateIcon(FocusFrame.TargetFrameContainer)
            CreateIcon(TargetFrameToT)
            CreateIcon(FocusFrameToT)

            local f = CreateFrame("Frame")
            f:RegisterEvent("PLAYER_TARGET_CHANGED")
            f:RegisterEvent("PLAYER_FOCUS_CHANGED")
            f:RegisterEvent("UNIT_TARGET")
            f:SetScript("OnEvent", function(self, event, unit, ...)
                if event == "UNIT_TARGET" and ValidUnits[unit] then
                    UpdatePortrait(ValidUnits[unit])
                elseif event == "PLAYER_TARGET_CHANGED" and
                    TargetFrame.TargetFrameContainer:IsShown() then
                    UpdatePortrait(TargetFrame.TargetFrameContainer)
                    if TargetFrameToT:IsShown() then
                        UpdatePortrait(TargetFrameToT)
                    end
                end
                if event == "PLAYER_FOCUS_CHANGED" and
                    FocusFrame.TargetFrameContainer:IsShown() then
                    UpdatePortrait(FocusFrame.TargetFrameContainer)
                    if FocusFrameToT:IsShown() then
                        UpdatePortrait(FocusFrameToT)
                    end
                end
            end)
        end
    end
    Portrait()

    -- ClassColored Target/Focus Healthbar
		
	local PlayerSpecific = {
        [PlayerFrame.PlayerFrameContent.PlayerFrameContentMain.HealthBarArea.HealthBar] = true 
    }
    local HealthBarWhitelist = { 
        [TargetFrame.TargetFrameContent.TargetFrameContentMain.HealthBar] = true,
        [TargetFrameToT.HealthBar] = true,
        [FocusFrame.TargetFrameContent.TargetFrameContentMain.HealthBar] = true,
        [FocusFrameToT.HealthBar] = true
    };
    local SavedBarColors = {};
    local function UnitFrameHealthBar_OnColorUpdate(self)
	if (not VREMON_STATE_DISABLED["UnitFrameHealthBar_OnColorUpdate"] and HealthBarWhitelist[self]) or 
    (not VREMON_STATE_DISABLED["UnitFrameHealthBar_OnColorUpdate_PlayerOnly"] and PlayerSpecific[self]) then
        if self.lockColor then 
            if not SavedBarColors[self] then
                SavedBarColors[self] = {self:GetStatusBarColor()};
            end
        else
            SavedBarColors[self] = nil;
        end     

        local unit = self.unit;
        local class = unit and select(2, UnitClass(unit));
        local color = class and RAID_CLASS_COLORS[class];

        if unit and UnitIsPlayer(unit) and UnitIsConnected(unit) and color then
            self:SetStatusBarDesaturated(true);
            self:SetStatusBarColor(color:GetRGB()); 
        else
            self:SetStatusBarDesaturated(false);
            if self.lockColor and SavedBarColors[self] then
                self:SetStatusBarColor(unpack(SavedBarColors[self]));
            end 
        end
	end	
    end
    hooksecurefunc("UnitFrameHealthBar_Update", UnitFrameHealthBar_OnColorUpdate);
    hooksecurefunc("HealthBar_OnValueChanged", UnitFrameHealthBar_OnColorUpdate);

    -- Target/Focus Frame Debuffs/Buffs rows distance between and size aura   
  
	local function SizeRowsBD(self)
	if not VREMON_STATE_DISABLED["SizeRowsBD"] then
	
    local Aura_Size = 24;
    local Aura_Spacing = 4;
    local Aura_ShortCols = 4; --   Buffs per short row
    local Aura_ShortRows = 2; --   Number of shortened rows
    local Aura_NormalCols = 6; --  Buffs per remaining rows

    --  Calculated Constants
    local Aura_ShortPadCols = Aura_NormalCols - Aura_ShortCols;
    local Aura_GridSize = Aura_Size + Aura_Spacing;
    local ProcessAuraList;
    do
        local AuraFrameMap = {};
        local BuffsOnTop, IsPrimaryAuraType, OtherTypeRowCount; 
        local AuraIndex, FirstAuraFrame; 
        local LastRowAuraFrame, RowCount; 
        local function ProcessAura(instanceid, aurainfo)
            local auraframe = AuraFrameMap[instanceid];
            if auraframe then
                AuraIndex, FirstAuraFrame = (AuraIndex or 0) + 1,
                                            FirstAuraFrame or auraframe;
                if AuraIndex > 1 then
                    local point, relframe, relpoint, offsetx, offsety =
                        FirstAuraFrame:GetPoint(1);

                    local posindex = AuraIndex - 1;
                    if not BuffsOnTop and
                        (IsPrimaryAuraType or OtherTypeRowCount < Aura_ShortRows) then
                        posindex = posindex +
                                       math.min(
                                           math.floor(posindex / Aura_ShortCols),
                                           Aura_ShortRows -
                                               (IsPrimaryAuraType and 0 or
                                                   OtherTypeRowCount)) *
                                       Aura_ShortPadCols;
                    end
                    local x, y = posindex % Aura_NormalCols,
                                 math.floor(posindex / Aura_NormalCols);
                    auraframe:SetPoint(point, relframe, relpoint,
                                       x * Aura_GridSize + offsetx,
                                       (BuffsOnTop and 1 or -1) * y *
                                           Aura_GridSize + offsety);
                    if x == 0 then
                        RowCount, LastRowAuraFrame = y + 1, auraframe;
                    end
                else
                    RowCount, LastRowAuraFrame = 1, auraframe;
                end
                auraframe:SetSize(Aura_Size, Aura_Size);
                if auraframe.Border then
                    auraframe.Border:SetSize(Aura_Size + 2, Aura_Size + 2);
                end
            end
        end
        function ProcessAuraList(self, auralist, isprimary, othersize, template,
                                 container)
            local numauras = auralist and auralist:Size() or 0;
            if numauras > 0 then
                for auraframe in self.auraPools:GetPool(template)
                                     :EnumerateActive() do
                    AuraFrameMap[auraframe.auraInstanceID] = auraframe;
                end
                AuraIndex, FirstAuraFrame = 0, nil;
                BuffsOnTop, IsPrimaryAuraType = self.buffsOnTop,
                                                isprimary or othersize <= 0;
                OtherTypeRowCount = IsPrimaryAuraType and 0 or
                                        math.floor(((othersize - 1) +
                                                       math.min(
                                                           math.floor(
                                                               (othersize - 1) /
                                                                   Aura_ShortCols),
                                                           Aura_ShortRows) *
                                                       Aura_ShortPadCols) /
                                                       Aura_NormalCols) + 1;
                auralist:Iterate(ProcessAura);
                local rowcount = RowCount or 0; 
                if LastRowAuraFrame then
                    if not isprimary or othersize <= 0 then
                        self.spellbarAnchor = LastRowAuraFrame;
                    end
                    container:SetPoint(select(3, LastRowAuraFrame:GetPoint(1)),
                                       LastRowAuraFrame, 0, self.buffsOnTop and
                                           Aura_Spacing or -Aura_Spacing);
                end
                AuraIndex, FirstAuraFrame = nil, nil;
                BuffsOnTop, IsPrimaryAuraType, OtherTypeRowCount = nil, nil, nil;
                RowCount, LastRowAuraFrame = nil, nil;
                table.wipe(AuraFrameMap);
                return rowcount;
            else
                return 0;
            end
        end
    end
    local function TargetFrame_UpdateAuras(self)
        local containerparent = self.TargetFrameContent
                                    .TargetFrameContentContextual;
        local numrows = 0;

        if UnitIsFriend("player", self.unit) then
            numrows = numrows +
                          ProcessAuraList(self, self.activeBuffs, true,
                                          self.activeDebuffs:Size(),
                                          "TargetBuffFrameTemplate",
                                          containerparent.buffs);
            numrows = numrows +
                          ProcessAuraList(self, self.activeDebuffs, false,
                                          self.activeBuffs:Size(),
                                          "TargetDebuffFrameTemplate",
                                          containerparent.debuffs);
        else
            numrows = numrows +
                          ProcessAuraList(self, self.activeDebuffs, true,
                                          self.activeBuffs:Size(),
                                          "TargetDebuffFrameTemplate",
                                          containerparent.debuffs);
            numrows = numrows +
                          ProcessAuraList(self, self.activeBuffs, false,
                                          self.activeDebuffs:Size(),
                                          "TargetBuffFrameTemplate",
                                          containerparent.buffs);
        end

        self.auraRows = numrows;
        if self.spellbar then self.spellbar:AdjustPosition(); end
    end
    hooksecurefunc(TargetFrame, "UpdateAuras", TargetFrame_UpdateAuras);
    hooksecurefunc(FocusFrame, "UpdateAuras", TargetFrame_UpdateAuras);
	end
	end
	SizeRowsBD()

    -- Miscellaneous+Cleaning

    local function PlayerFrameGlowing(self)
        local statusGlowing = PlayerFrame.PlayerFrameContent
                                  .PlayerFrameContentMain.StatusTexture
        statusGlowing:Hide()
    end
    hooksecurefunc("PlayerFrame_UpdateStatus", PlayerFrameGlowing)
    
	local function PortraitHitNumbers(self)
	 if not VREMON_STATE_DISABLED["PortraitHitNumbers"] then
    PlayerFrame:UnregisterEvent("UNIT_COMBAT")
	end
	end
	PortraitHitNumbers()
	
    TargetFrame.TargetFrameContent.TargetFrameContentMain.ReputationColor:SetTexture(nil)	
    FocusFrame.TargetFrameContent.TargetFrameContentMain.ReputationColor:SetTexture(nil)
   		
	local playerFrameContextual = PlayerFrame.PlayerFrameContent.PlayerFrameContentContextual
	local targetFrameContextual = TargetFrame.TargetFrameContent.TargetFrameContentContextual
	local focusFrameContextual = FocusFrame.TargetFrameContent.TargetFrameContentContextual
    for i, v in pairs({
    playerFrameContextual.RoleIcon,
    playerFrameContextual.LeaderIcon,
    playerFrameContextual.PlayerRestLoop,
    playerFrameContextual.PrestigeBadge,
    playerFrameContextual.PrestigePortrait,
    playerFrameContextual.GroupIndicator,
    playerFrameContextual.PVPIcon,
    targetFrameContextual.PrestigeBadge,
    targetFrameContextual.GuideIcon,
    targetFrameContextual.PrestigePortrait,
    targetFrameContextual.PvpIcon,
    targetFrameContextual.LeaderIcon,
    focusFrameContextual.LeaderIcon,
    focusFrameContextual.PvpIcon,
    focusFrameContextual.GuideIcon,
    focusFrameContextual.PrestigePortrait,
    focusFrameContextual.PrestigeBadge,
    }) 
	do 
     v:SetAlpha(0)
    end	
    	
	local function StatusHXRbar(self)
	if not VREMON_STATE_DISABLED["HXRbar"] then
	StatusTrackingBarManager:SetAlpha(0)
	else
	StatusTrackingBarManager:SetAlpha(1)
	end
	end
	StatusHXRbar()
	

    local function ErrorRedText(self)
	if not VREMON_STATE_DISABLED["ErrorRedText"] then
	UIErrorsFrame:SetAlpha(0)
	else
	UIErrorsFrame:SetAlpha(1)
	end
	end
	ErrorRedText()

   --Cvar
   
	C_CVar.SetCVar("cameraPivot", 0) -- 1
    C_CVar.SetCVar("threatWarning", 0) -- 3
	C_CVar.SetCVar("nameplateOtherTopInset", -1) -- 0.08
    C_CVar.SetCVar("nameplateOtherBottomInset", -1) --  0.1
	C_CVar.SetCVar("cameraDistanceMaxZoomFactor", 2.3) -- 1.9 
		
    -- CVar
    
	local function CVar(self)
	if not VREMON_STATE_DISABLED["CVar"] then
	C_CVar.SetCVar("nameplateMinAlpha", 1.0) -- 0.6
	C_CVar.SetCVar("nameplateOccludedAlphaMult", 1) -- 0.4
	else
    C_CVar.SetCVar("nameplateMinAlpha", 0.6) 
	C_CVar.SetCVar("nameplateOccludedAlphaMult", 0.4) 
	end
	end
	CVar()
	
	local function CompactTextDamage(self)
	if not VREMON_STATE_DISABLED["CompactTextDamage"] then
	C_CVar.SetCVar("floatingCombatTextCombatDamageDirectionalScale", 0) -- 1
	C_CVar.SetCVar("floatingCombatTextCombatLogPeriodicSpells", 0) -- 1
	C_CVar.SetCVar("breakUpLargeNumbers", 0) -- 1
	C_CVar.SetCVar("WorldTextScale", 0.9) -- 1.0
	C_CVar.SetCVar("WorldTextCritScreenY", 0.0426) -- 0.0275
    C_CVar.SetCVar("WorldTextScreenY", 0.053) -- 0.015
    C_CVar.SetCVar("WorldTextGravity", 0.0) -- 0.5
	else
	C_CVar.SetCVar("floatingCombatTextCombatDamageDirectionalScale", 1)
	C_CVar.SetCVar("floatingCombatTextCombatLogPeriodicSpells", 1) 
	C_CVar.SetCVar("breakUpLargeNumbers", 1) -- 1
	C_CVar.SetCVar("WorldTextScale", 1.0)
	C_CVar.SetCVar("WorldTextCritScreenY", 0.0275) 
    C_CVar.SetCVar("WorldTextScreenY", 0.015) 
    C_CVar.SetCVar("WorldTextGravity", 0.5) 
	
	end
	end
	CompactTextDamage()
	
	
	
	local function FrendlyNCC(self)
	if not VREMON_STATE_DISABLED["FrendlyNCC"] then
	C_CVar.SetCVar("ShowClassColorInFriendlyNameplate", 0)
	else
	C_CVar.SetCVar("ShowClassColorInFriendlyNameplate", 1)
	end
	end
	FrendlyNCC()
	
	
	local function HideKeybinds(self)
    if not VREMON_STATE_DISABLED["HideKeybinds"] then 
    for i = 1, 12 do
        _G["MultiBarBottomLeftButton" .. i .. "HotKey"]:SetAlpha(0)
        _G["MultiBarBottomRightButton" .. i .. "HotKey"]:SetAlpha(0)
        _G["ActionButton" .. i .. "HotKey"]:SetAlpha(0)
		_G["MultiBarRightButton" .. i .. "HotKey"]:SetAlpha(0)
        _G["MultiBarLeftButton" .. i .. "HotKey"]:SetAlpha(0)
        _G["MultiBar5Button" .. i .. "HotKey"]:SetAlpha(0)
        _G["MultiBar6Button" .. i .. "HotKey"]:SetAlpha(0)
        _G["MultiBar7Button" .. i .. "HotKey"]:SetAlpha(0)	
    end
	end
    end
    HideKeybinds()
	
	local function HideMacro(self)
    if not VREMON_STATE_DISABLED["HideMacro"] then 
    for i = 1, 12 do
        _G["ActionButton" .. i .. "Name"]:SetAlpha(0)
        _G["MultiBarBottomRightButton" .. i .. "Name"]:SetAlpha(0)
        _G["MultiBarBottomLeftButton" .. i .. "Name"]:SetAlpha(0)
		_G["MultiBarRightButton" .. i .. "Name"]:SetAlpha(0)
        _G["MultiBarLeftButton" .. i .. "Name"]:SetAlpha(0)
        _G["MultiBar5Button" .. i .. "Name"]:SetAlpha(0)
        _G["MultiBar6Button" .. i .. "Name"]:SetAlpha(0)
        _G["MultiBar7Button" .. i .. "Name"]:SetAlpha(0)
    end
	end
    end
    HideMacro()
	
	
    -- LossControlSelf

    LossOfControlFrame:ClearAllPoints()
    LossOfControlFrame:SetPoint("CENTER", UIParent, "CENTER", 64, 0)
    LossOfControlFrame.TimeLeft.SecondsText:SetAlpha(0)
    LossOfControlFrame.AbilityName:SetAlpha(0)
    select(1, LossOfControlFrame:GetRegions()):SetAlpha(0)
    select(2, LossOfControlFrame:GetRegions()):SetAlpha(0)
    select(3, LossOfControlFrame:GetRegions()):SetAlpha(0)

    -- Remove Realmname on Nameplates 
	     
    local nameToIcon = {
        ["Grounding Totem"] = "Interface\\Icons\\Spell_Nature_GroundingTotem",
        ["Earthbind Totem"] = "Interface\\Icons\\spell_nature_strengthofearthtotem02",
        ["Skyfury Totem"] = "Interface\\Icons\\spell_fire_totemofwrath",
        ["Static Field Totem"] = "Interface\\Icons\\spell_shaman_stormtotem",
        ["Capacitor Totem"] = "Interface\\Icons\\spell_nature_brilliance",
        ["Healing Tide Totem"] = "Interface\\Icons\\ability_shaman_healingtide",
        ["Healing Stream Totem"] = "Interface\\Icons\\inv_spear_04",
        ["Tremor Totem"] = "Interface\\Icons\\spell_nature_tremortotem",
        ["Earthen Wall Totem"] = "Interface\\Icons\\spell_nature_stoneskintotem",
        ["Cloudburst Totem"] = "Interface\\Icons\\ability_shaman_condensationtotem",
        ["Wind Rush Totem"] = "Interface\\Icons\\ability_shaman_windwalktotem",
        ["Spirit Link Totem"] = "Interface\\Icons\\spell_shaman_spiritlink",
        ["Earthgrab Totem"] = "Interface\\Icons\\spell_nature_stranglevines",
        ["Psyfiend"] = "Interface\\Icons\\spell_priest_psyfiend",
        ["War Banner"] = "Interface\\Icons\\warrior_skullbanner",
        ["Demonic Tyrant"] = "Interface\\Icons\\inv_summondemonictyrant",
        ["Fel Lord"] = "Interface\\Icons\\achievement_boss_hellfire_fellord",
        ["Infernal"] = "Interface\\Icons\\spell_shadow_summoninfernal",
        ["Shadowfiend"] = "Interface\\Icons\\spell_shadow_shadowfiend",
        ["Rattling Mage"] = "Interface\\Icons\\inv_armor_maldraxxuscosmetic_d_01_helm",
        ["Primal Fire Elemental"] = "Interface\\Icons\\spell_fire_elemental_totem",
        ["Greater Fire Elemental"] = "Interface\\Icons\\spell_fire_elemental_totem",
        ["Fel Obelisk"] = "Interface\\Icons\\ability_felshieldemitter",
        ["Counterstrike Totem"] = "Interface\\Icons\\spell_nature_wrathofair_totem",
        ["Mana Tide Totem"] = "Interface\\Icons\\spell_frost_summonwaterelemental",
        ["Windfury Totem"] = "Interface\\Icons\\spell_nature_windfury",
        ["Xuen"] = "Interface\\Icons\\ability_monk_summontigerstatue",
        ["Darkglare"] = "Interface\\Icons\\inv_beholderwarlock",
        ["Alliance Battle Standard"] = "Interface\\Icons\\inv_bannerpvp_02",
        ["Horde Battle Standard"] = "Interface\\Icons\\inv_bannerpvp_01",
		["Void Tendril"] = "Interface\\Icons\\spell_priest_voidtendrils",

        ["Totem der Erdung"] = "Interface\\Icons\\Spell_Nature_GroundingTotem",
        ["Totem der Erdbindung"] = "Interface\\Icons\\spell_nature_strengthofearthtotem02",
        ["Totem des Himmelszorns"] = "Interface\\Icons\\spell_fire_totemofwrath",
        ["Statisches Feldtotem"] = "Interface\\Icons\\spell_shaman_stormtotem",
        ["Totem der Energiespeicherung"] = "Interface\\Icons\\spell_nature_brilliance",
        ["Totem der Heilungsflut"] = "Interface\\Icons\\ability_shaman_healingtide",
        ["Totem des heilenden Flusses"] = "Interface\\Icons\\inv_spear_04",
        ["Totem des Erdstoßes"] = "Interface\\Icons\\spell_nature_tremortotem",
        ["Totem des irdenen Walls"] = "Interface\\Icons\\spell_nature_stoneskintotem",
        ["Totem des Wolkenbruchs"] = "Interface\\Icons\\ability_shaman_condensationtotem",
        ["Totem des Windsturms"] = "Interface\\Icons\\ability_shaman_windwalktotem",
        ["Totem der Geistverbindung"] = "Interface\\Icons\\spell_shaman_spiritlink",
        ["Totem des Erdgriffs"] = "Interface\\Icons\\spell_nature_stranglevines",
        ["Psychoschrecken"] = "Interface\\Icons\\spell_priest_psyfiend",
        ["Kriegsbanner"] = "Interface\\Icons\\warrior_skullbanner",
        ["Dämonischer Tyrann"] = "Interface\\Icons\\inv_summondemonictyrant",
        ["Teufelslord"] = "Interface\\Icons\\achievement_boss_hellfire_fellord",
        ["Höllenbestie"] = "Interface\\Icons\\spell_shadow_summoninfernal",
        ["Schattengeist"] = "Interface\\Icons\\spell_shadow_shadowfiend",
        ["Rattling Mage"] = "Interface\\Icons\\inv_armor_maldraxxuscosmetic_d_01_helm",
        ["Feuerelementar"] = "Interface\\Icons\\spell_fire_elemental_totem",
        ["Urfeuerelementar"] = "Interface\\Icons\\spell_fire_elemental_totem",
        ["Teufelsobelisk"] = "Interface\\Icons\\ability_felshieldemitter",
        ["Totem des Gegenschlags"] = "Interface\\Icons\\spell_nature_wrathofair_totem",
        ["Totem der Manaflut"] = "Interface\\Icons\\spell_frost_summonwaterelemental",
        ["Totem des Windzorns"] = "Interface\\Icons\\spell_nature_windfury",
        ["Xuen"] = "Interface\\Icons\\ability_monk_summontigerstatue",
        ["Dunkelblick"] = "Interface\\Icons\\inv_beholderwarlock",
        ["Schlachtstandarte der Allianz"] = "Interface\\Icons\\inv_bannerpvp_02",
        ["Schlachtstandarte der Horde"] = "Interface\\Icons\\inv_bannerpvp_01"

    }

    local function HideNameplates(self)
        if (not strfind(self.unit, "nameplate") or self:IsForbidden()) then
            return
        end
		if not VREMON_STATE_DISABLED["HideNameplates"] then
        local foundSomething = false
        for name, icon in pairs(nameToIcon) do
            if UnitName(self.unit):match(name) then 
                self.name:SetText("|T" .. icon .. ":21|t")
                self.name:Show()
                foundSomething = true
                break
            end
        end
		end
        if not foundSomething then
            if (UnitIsPlayer(self.unit)) then
                self.name:SetText(UnitName(self.unit))
            end
        end
    end
    hooksecurefunc("CompactUnitFrame_UpdateName", HideNameplates)
	
	--ToT Position
		
	local function ToT(Targetof)
    Targetof:ClearAllPoints()
    Targetof:SetPoint("LEFT", Targetof:GetParent(), "CENTER", 13, -50)
    end
    local ToTPoint = CreateFrame("Frame")
    ToTPoint:RegisterEvent("PLAYER_ENTERING_WORLD")
    ToTPoint:SetScript("OnEvent", function(self, event)
	if not VREMON_STATE_DISABLED["TFToT"] then
    if event == ("PLAYER_ENTERING_WORLD") then
        ToT(TargetFrameToT)
        ToT(FocusFrameToT)
    end
    end
	end)
	

end

Vremon:RegisterEvent("PLAYER_LOGIN")
Vremon:SetScript("OnEvent", Vremon_OnLoad)
